use <../libs/polyhole.scad>

layersize=5;
play=0.5;
ropesize=20;

module eyelet()
    {
    difference()
        {
        cylinder(r=ropesize/2+2,h=2);
        translate([0,0,-1])
            cylinder(r=ropesize/2,h=4);
        }
    }

module latch_neg()
    {
    difference()
        {
        cube([20+play,60+play,layersize*2+play]);
        translate([10,0,-1])
            rotate([0,0,-20])
                cube([20+play,60+play,layersize*2+2+play]);
        }
    }

module latch()
    {
    difference()
        {
        cube([20,60,layersize*2]);
        translate([10,0,-1])
            rotate([0,0,-20])
                cube([20+play,60+play,layersize*2+2+play]);
        scale([1,1,2])
            translate([12,20,-layersize/2])
                lock_neg();
        }
    translate([ropesize/2,ropesize/2+60.1,0])
        eyelet();
    }

module lock_neg()
    {
    difference()
        {
        cube([30,10,layersize*2]);
        rotate([0,0,-10])
            translate([-15,-2,-1])
                cube([15,15,layersize*2+2]);
        }
    }

module lock()
    {
    difference()
        {
        cube([10,10-play,layersize*2-play]);
        rotate([0,0,-10])
            translate([-15,-2,-1])
                cube([15,15,layersize*2+2]);
        translate([2,5-play/2,5-play/2])
            rotate([0,90,0])
                polyhole(d=2.9,h=10);
        }
    }

module plate1()
    {
    translate([ropesize/2+40.1,0,0])
        eyelet();
    difference()
        {
        union()
            {
            translate([-10,-20,0])
                cube([50,70,layersize*2]);
            translate([37,25,layersize*2])
                rotate([0,90,0])
                    cylinder(r=7.5,h=3);
            }
        translate([0,0,layersize-play])
            latch_neg();
        translate([8,20,layersize-play])
            lock_neg();
        translate([-20,-10,layersize])
            rotate([0,90,0])
                linear_extrude(height=100)
                    {
                    polygon([[play,-6-play/2],[play,6+play/2],[-layersize-play/2,3+play/2],[-layersize-play,-3-play/2]]);
                    translate([0,50,0])
                        polygon([[play,-6-play/2],[play,6+play/2],[-layersize-play/2,3+play/2],[-layersize-play,-3-play/2]]);
                    }
        translate([25,25,layersize*2])
            rotate([0,90,0])
                polyhole(20,5);
        translate([27,7,-1])
            cylinder(r=10,h=layersize*5);
        }
    }

module plate2()
    {
    translate([-ropesize/2-10.1,0,layersize*4-2])
        eyelet();
    difference()
        {
        union()
            {
            translate([-10,-20,layersize*2])
                cube([50,70,layersize*2]);
            translate([-10,-10,layersize+0.001])
                rotate([0,90,0])
                    linear_extrude(height=50)
                        {
                        polygon([[0,-6],[0,6],[-layersize,3],[-layersize,-3]]);
                        translate([0,50,0])
                            polygon([[play,-6-play/2],[play,6+play/2],[-layersize-play/2,3+play/2],[-layersize-play,-3-play/2]]);
                        }
            }
        translate([0,0,layersize+play])
            latch_neg();
            translate([0,0,0])
            latch_neg();
        translate([8,20,layersize+play*2])
            lock_neg();
        translate([37.1,25,layersize*2])
            rotate([0,90,0])
                polyhole(3,15);
        translate([27,7,-1])
            cylinder(r=10,h=layersize*5);
        }
    
    }

module unlock_eyelet()
    {
    difference()
        {
        union()
            {
            translate([-1,0,ropesize/2+2.1])
                rotate([0,90,0])
                    eyelet();
            cylinder(r=7,h=2);
            }
        translate([0,0,-1])
            polyhole(h=4,d=3);
        }
    }

plate1();
rotate([0,180,180])
    translate([-60,-30,-layersize*4])
        plate2();

translate([20,55,0])
    lock();

translate([0,55,0])
    rotate([0,0,90])
        latch();

translate([10,70,0])
    unlock_eyelet();
